let ascii = ref false

let arg = ref None

let usage = "./pp_sudoku [--ascii]"

let spec =
  [ "--ascii",        Arg.Set ascii,        "\tonly uses ascii characters"]

let split_line = "+---+---+---+---+---+---+---+---+---+\n"
let split_hollow = "+   +   +   +   +   +   +   +   +   +\n"


let () =
  Arg.parse spec (fun s -> arg := Some s) usage;
  let sudoku_str =
    match !arg with
    | None -> read_line ()
    | Some s -> s
  in
  print_string split_line ;
  for i = 0 to 8 do
    print_char '|' ;
    for j = 0 to 8 do
      let chr = if sudoku_str.[9 * i + j] = '0' then
          ' ' else sudoku_str.[9 * i + j] in
      print_char ' ' ;
      print_char chr ;
      print_char ' ' ;
      print_char (if j mod 3 = 2 then '|' else ' ')
    done ;
    print_newline () ;
    print_string (if i mod 3 = 2 then split_line else split_hollow) ;
  done ;

